#define WIN32_LEAN_AND_MEAN
#define VC_EXTRALEAN
#include <windows.h>
#include "D3DGraphics.h"
#include "Game.h"

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message) 
	{
			//case WM_COMMAND:
			  // handle menu selections etc.
			//break;
			//case WM_PAINT:
			  // draw our window - note: you must paint something here or not trap it!
			//break;
			/*case WM_MOUSEMOVE:
			{

				// Retrieve mouse screen position
				int x=(short)LOWORD(lParam);
				int y=(short)HIWORD(lParam);

				// Check to see if the left button is held down:
				bool leftButtonDown = wParam & MK_LBUTTON;

				// Check if right button down:
				bool rightButtonDown = wParam & MK_RBUTTON;

			}*/
			/*case WM_LBUTTONDOWN:
			{
			}
			case WM_RBUTTONDOWN:
			{
			}
			case WM_LBUTTONUP:
			{
			}
			case WM_RBUTTONUP:
			{
			}*/
			case WM_DESTROY:
				 PostQuitMessage( 0 );
			break;
			default:
				// We do not want to handle this message so pass back to Windows
				// to handle it in a default way
				return DefWindowProc( hWnd, message, wParam, lParam );
	}

	return 0;
}

int APIENTRY WinMain( HINSTANCE hInstance, HINSTANCE hPrevInstance, LPSTR lpCmdLine, int nCmdShow )
{
	WNDCLASSEX wcex;
		wcex.cbSize = sizeof(WNDCLASSEX); 
		wcex.style= CS_HREDRAW | CS_VREDRAW;
		wcex.lpfnWndProc= (WNDPROC)WndProc;
		wcex.cbClsExtra= 0;
		wcex.cbWndExtra= 0;
		wcex.hInstance= hInstance;
		wcex.hIcon= 0;
		wcex.hCursor= LoadCursor(NULL, IDC_ARROW);
		wcex.hbrBackground= (HBRUSH)(COLOR_WINDOW+1);
		wcex.lpszMenuName= 0;
		wcex.lpszClassName= "MyWindowClass";
		wcex.hIconSm= 0;

	RegisterClassEx( &wcex );

	HWND hWnd = CreateWindow("MyWindowClass", "Pubes", WS_OVERLAPPEDWINDOW, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, CW_USEDEFAULT, NULL, NULL, hInstance, NULL);
	Game theGame = Game( hWnd );

	ShowWindow(hWnd, nCmdShow);
	UpdateWindow(hWnd);

	MSG msg;
	/*while (GetMessage(&msg, NULL, 0, 0)) 
	{
		 TranslateMessage(&msg);
		 DispatchMessage(&msg);
	}*/

	ZeroMemory( &msg, sizeof(msg) );

	while( msg.message!=WM_QUIT )
	{
	   if( PeekMessage( &msg, NULL, 0U, 0U, PM_REMOVE ) )
	   {
		  TranslateMessage( &msg );
		  DispatchMessage( &msg );
	   }
	   else
	   {
			theGame.Go();
	   }
	}

}