#include "Game.h"

Game::Game( HWND hWnd )
	:
	gfx( hWnd )
{
	sprite = NULL;

	if ( SUCCEEDED( D3DXCreateSprite( gfx.d3dDevice, &sprite ) ) )
	{
		 // created OK
	}	

	pos.x=10.0f;
	pos.y=20.0f;
	pos.z=0.0f;

	gTexture = NULL;

	D3DXCreateTextureFromFile( gfx.d3dDevice, "Images/character001.png", &gTexture );
};

Game::~Game()
{
	sprite->Release();
	gTexture->Release(); 
};

void Game::Go()
{
	gfx.Begin();
	ComposeFrame();
	gfx.Present();
	gfx.End();
};

void Game::ComposeFrame()
{
	sprite->Begin( D3DXSPRITE_ALPHABLEND );
	sprite->Draw( gTexture, NULL, NULL, &pos, 0xFFFFFFFF );
	sprite->End();
}